/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of ClearSilver.xs. Do not edit this file, edit ClearSilver.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "xs/ClearSilver.xs"
/*
    Text-ClearSilver.xs -  The template processor class

    Copyright(c) 2010 Craftworks. All rights reserved.

    See lib/Text/ClearSilver.pm for details.
*/

#define NEED_newSVpvn_flags_GLOBAL
#define NO_XSLOCKS
#include "Text-ClearSilver.h"

#define MY_CXT_KEY "Text::ClearSilver::_guts" XS_VERSION
/* my_cxt_t is defined in Text-ClearSilver.h */
START_MY_CXT

/* my_cxt accessor for HDF.xs */
my_cxt_t*
tcs_get_my_cxtp(pTHX) {
    dMY_CXT;
    return &MY_CXT;
}

/* ClearSilver can access ibuf out of range of memory :(
   so extra some memory must be allocated for cs_parse_string().
*/
static const size_t extra_bytes = 8;

/*
    NOTE: Currently, file_cache is always enabled, although it can be disabled.
 */

static NEOERR*
tcs_fileload(void* vcsparse, HDF* const hdf, const char* filename, char** const contents) {
    dTHX;
    dMY_CXT;
    I32 filename_len;
    NEOERR* err = STATUS_OK;
    char fpath[_POSIX_PATH_MAX];
    Stat_t st;
    bool stat_ok = FALSE;

    /* find file */
    if (filename[0] != '/') {
        err = hdf_search_path (hdf, filename, fpath);
        if (((CSPARSE*)vcsparse)->global_hdf && nerr_handle(&err, NERR_NOT_FOUND)) {
            err = hdf_search_path(((CSPARSE*)vcsparse)->global_hdf, filename, fpath);
        }
        if (err != STATUS_OK) return nerr_pass(err);

        filename      = fpath;
    }
    filename_len = strlen(filename);

    /* check cache */
    if(MY_CXT.file_cache){
        SV** const svp = hv_fetch(MY_CXT.file_cache, filename, filename_len, FALSE);

        if(svp){
            SV* const mtime_cache    = AvARRAY(SvRV(*svp))[0];
            SV* const contents_cache = AvARRAY(SvRV(*svp))[1];

            if(PerlLIO_stat(filename, &st) < 0) {
                return nerr_raise(NERR_IO, "Failed to stat(%s): %s", filename, Strerror(errno));
            }
            stat_ok = TRUE;

            assert(SvIOK(mtime_cache));
            assert(SvPOK(contents_cache));

            if(st.st_mtime == SvIVX(mtime_cache)) {
                *contents = (char*)malloc(st.st_size + extra_bytes);
                Copy(SvPVX(contents_cache), *contents, st.st_size + 1, char);
                return STATUS_OK;
            }
        }
    }

    /* load file normally */
    if(!(stat_ok || PerlLIO_stat(filename, &st) >= 0)) {
        return nerr_raise(NERR_IO, "Failed to stat(%s): %s", filename, Strerror(errno));
    }

    ENTER;
    SAVETMPS;
    {
        SV* namesv = newSVpvn_flags(filename, filename_len, SVs_TEMP);
        SV* file_buf;
        PerlIO* const ifp =  PerlIO_openn(aTHX_
            MY_CXT.input_layer, "r", -1, O_RDONLY, 0, NULL, 1, &namesv);

        if(!ifp){
            err = nerr_raise(NERR_IO, "Failed to open %s: %s", filename, Strerror(errno));
            goto cleanup;
        }

        file_buf = sv_2mortal(newSV(st.st_size));

        /* local $/ = undef */
        SAVESPTR(PL_rs);
        PL_rs = &PL_sv_undef;

        sv_gets(file_buf, ifp, FALSE);

        if(PerlIO_error(ifp)) {
            PerlIO_close(ifp);
            err = nerr_raise(NERR_IO, "Failed to gets");
            goto cleanup;
        }

        PerlIO_close(ifp);

        *contents = (char*)malloc(SvCUR(file_buf) + extra_bytes);
        Copy(SvPVX(file_buf), *contents, SvCUR(file_buf) + 1, char);

        if(MY_CXT.file_cache){
            SV* cache_entry[2]; /* mtime, contents */

            cache_entry[0] = newSViv(st.st_mtime);
            cache_entry[1] = SvREFCNT_inc_simple_NN(file_buf);

            (void)hv_store(MY_CXT.file_cache, filename, filename_len,
                newRV_noinc((SV*)av_make(2, cache_entry)), 0U);
        }
    }

    cleanup:
    FREETMPS;
    LEAVE;
    return err;
}

/* in csparse.c */
NEOERR*
tcs_eval_expr(CSPARSE* parse, CSARG* arg, CSARG* result);
const char*
tcs_var_lookup(CSPARSE* parse, const char* name);
long
tcs_var_int_lookup(CSPARSE* parse, const char* name);
HDF*
tcs_var_lookup_obj(CSPARSE* parse, const char* name);

static NEOERR*
tcs_push_args(pTHX_ CSPARSE* const parse, CSARG* args, const bool utf8) {
    dSP;

    PUSHMARK(SP);

    while(args) {
        const char* str;
        CSARG val;
        NEOERR* err;
        SV* sv;

        err = tcs_eval_expr(parse, args, &val);

        if(err){
            (void)POPMARK;

            return nerr_pass(err);
        }

        sv = sv_newmortal();
        XPUSHs(sv);

        switch(val.op_type & CS_TYPES){
        case CS_TYPE_STRING:
            assert(val.s);
            sv_setpv(sv, val.s);
            if(utf8) {
                sv_utf8_decode(sv);
            }
            break;

        case CS_TYPE_VAR:
            assert(val.s);
            str = tcs_var_lookup(parse, val.s);
            if(str) {
                sv_setpv(sv, str);
                if(utf8) {
                    sv_utf8_decode(sv);
                }
            }
            else { /* HDF node */
                HDF* const hdf = tcs_var_lookup_obj(parse, val.s);
                if(hdf) {
                    sv_setref_pv(sv, C_HDF, hdf);
                }
            }
            break;

        case CS_TYPE_NUM:
            sv_setiv(sv, val.n);
            break;

        case CS_TYPE_VAR_NUM:
            assert(val.s);
            sv_setiv(sv, tcs_var_int_lookup(parse, val.s));
            break;

        default:
            /* something's wrong? */
            break;
        }

        if(val.alloc){
            free(val.s);
        }
        args = args->next;
    }
    PUTBACK;
    return STATUS_OK;
}

/* general cs function wrapper */
static NEOERR*
tcs_function_wrapper(CSPARSE* const parse, CS_FUNCTION* const csf, CSARG* const args, CSARG* const result) {
    dTHX;
    dMY_CXT;
    SV** svp;
    SV* retval;
    NEOERR* err;

    assert(MY_CXT.functions);

    /* XXX: Hey! csf->name_len is not set!! */
    //svp = hv_fetch(MY_CXT.functions, csf->name, csf->name_len, FALSE);
    svp = hv_fetch(MY_CXT.functions, csf->name, strlen(csf->name), FALSE);
    if(!( svp && SvROK(*svp) && SvTYPE(SvRV(*svp)) == SVt_PVAV
            && (svp = av_fetch((AV*)SvRV(*svp), 0, FALSE)) )){
        return nerr_raise(NERR_ASSERT, "Function entry for %s() is broken", csf->name);
    }

    ENTER;
    SAVETMPS;

    err = tcs_push_args(aTHX_ parse, args, MY_CXT.utf8); /* PUSHMARK & PUSH & PUTBACK */
    if(err != STATUS_OK) {
        err = nerr_pass(err);
        goto cleanup;
    }

    call_sv(*svp, G_SCALAR | G_EVAL);

    {
        dSP;
        SPAGAIN;
        retval = POPs;
        PUTBACK;
    }

    if(sv_true(ERRSV)){
        err =  nerr_raise(NERR_ASSERT,
            "Function %s() died: %s", csf->name, SvPV_nolen_const(ERRSV));
        goto cleanup;
    }

    if(!((SvTYPE(retval) & SVf_OK) == SVf_IOK && PERL_ABS(SvIVX(retval)) <= PERL_LONG_MAX)) {
        STRLEN len;
        const char* const pv = SvPV_const(retval, len);
        len++; /* '\0' */

        result->op_type = CS_TYPE_STRING;
        result->s       = (char*)malloc(len);
        result->alloc    = TRUE;
        Copy(pv, result->s, len, char);
    }
    else { /* SvIOK */
        result->op_type = CS_TYPE_NUM;
        result->n       = (long)SvIVX(retval);
    }

    cleanup:
    FREETMPS;
    LEAVE;

    return err;
}

NEOERR*
tcs_parse_sv(pTHX_ CSPARSE* const parse, SV* const sv) {
    STRLEN str_len;
    const char* const str = SvPV_const(sv, str_len);

    char* const ibuf = (char*)malloc(str_len + extra_bytes);
    if(ibuf == NULL){
        return nerr_raise (NERR_NOMEM,
            "Unable to allocate memory");
    }

    Copy(str, ibuf, str_len + 1, char); /* with '\0' */
    return cs_parse_string(parse, ibuf, str_len);
}

void
tcs_throw_error(pTHX_ NEOERR* const err) {
    SV* sv;
    STRING errstr;
    string_init(&errstr);
    nerr_error_string(err, &errstr);
    sv = newSVpvn_flags(errstr.buf, errstr.len, SVs_TEMP);
    string_clear(&errstr);

    Perl_croak(aTHX_ "ClearSilver: %"SVf, sv);
}


static CV*
tcs_sv2cv(pTHX_ SV* const func) {
    HV* stash; /* unused */
    GV* gv;    /* unused */
    CV* const cv = sv_2cv(func, &stash, &gv, 0);
    if(!cv){
        croak("Not a CODE reference");
    }
    return cv;
}

static HV*
tcs_deref_hv(pTHX_ SV* const hvref) {
    if(!(SvROK(hvref) && SvTYPE(SvRV(hvref)) == SVt_PVHV)) {
        croak("Not a HASH reference");
    }
    return (HV*)SvRV(hvref);
}


static const char*
tcs_get_class_name(pTHX_ SV* const self) {
    if(SvROK(self) && SvOBJECT(SvRV(self))){
        HV* const stash = SvSTASH(SvRV(self));
        return HvNAME_get(stash);
    }
    else {
        return SvPV_nolen_const(self);
    }
}

static bool
tcs_is_utf8(pTHX_ SV* const tcs) {
    SV** const svp = hv_fetchs(tcs_deref_hv(aTHX_ tcs), "utf8", FALSE);
    return svp ? sv_true(*svp) : FALSE;
}


static void
tcs_register_function(pTHX_ SV* const self, SV* const name, SV* const func, IV const n_args) {
    SV** const svp = hv_fetchs(tcs_deref_hv(aTHX_ self), "functions", FALSE);
    HV* hv;
    SV* pair[2];
    if(svp) {
        hv = tcs_deref_hv(aTHX_ *svp);
    }
    else {
        hv = newHV();
        (void)hv_stores(tcs_deref_hv(aTHX_ self), "functions", newRV_noinc((SV*)hv));
    }

    pair[0] = newRV_inc((SV*)tcs_sv2cv(aTHX_ func));
    pair[1] = newSViv(n_args);

    (void)hv_store_ent(hv, name, newRV_noinc((SV*)av_make(2, pair)), 0U);
}
static void
tcs_load_function_set(pTHX_ SV* const self, SV* const val) {
    dMY_CXT;

    ENTER;
    SAVETMPS;

    if(!MY_CXT.function_set_is_loaded){
        require_pv("Text/ClearSilver/FunctionSet.pm");
        if(sv_true(ERRSV)){
            croak("ClearSilver: panic: %"SVf, ERRSV);
        }
        MY_CXT.function_set_is_loaded = TRUE;
    }

    SAVESPTR(ERRSV);
    ERRSV = sv_newmortal();
    {
        dSP;
        HV* set;
        HE* he;

        PUSHMARK(SP);
        EXTEND(SP, 2);
        PUSHs(newSVpvs_flags("Text::ClearSilver::FunctionSet", SVs_TEMP));
        PUSHs(val);
        PUTBACK;
        call_method("load", G_SCALAR | G_EVAL);

        if(sv_true(ERRSV)){
            croak("ClearSilver: cannot load a function set: %"SVf, ERRSV);
        }

        SPAGAIN;
        set = tcs_deref_hv(aTHX_ POPs);
        PUTBACK;

        hv_iterinit(set);
        while((he = hv_iternext(set))){
            tcs_register_function(aTHX_ self, hv_iterkeysv(he), hv_iterval(set, he), -1);
        }
    }
    FREETMPS;
    LEAVE;
}

static void
tcs_set_config(pTHX_ SV* const self, HV* const hv, HDF* const hdf, SV* const key, SV* const val) {
    const char* const keypv = SvPV_nolen_const(key);
    if(isUPPER(*keypv)){ /* builtin config */
        HDF* config;
        CHECK_ERR( hdf_get_node(hdf, "Config", &config) );
        CHECK_ERR( hdf_set_value(config, keypv, SvPV_nolen_const(val)) );
    }
    else { /* extended config */
        if(strEQ(keypv, "encoding")) {
            const char* const valpv = SvPV_nolen_const(val);
            bool utf8;
            if(strEQ(valpv, "utf8")){
                utf8 = TRUE;
            }
            else if(strEQ(valpv, "bytes")){
                utf8 = FALSE;
            }
            else {
                croak("ClearSilver: encoding must be 'utf8' or 'bytes', not '%s'", valpv);
            }
            (void)hv_stores(hv, "utf8", newSViv(utf8));
        }
        else if(strEQ(keypv, "input_layer")){
            (void)hv_stores(hv, "input_layer", newSVsv(val));
        }
        else if(strEQ(keypv, "dataset")) {
            tcs_hdf_add(aTHX_ hdf, val, tcs_is_utf8(aTHX_ self));
        }
        else if(strEQ(keypv, "load_path")) {
            HDF* loadpaths;
            CHECK_ERR( hdf_get_node(hdf, "hdf.loadpaths", &loadpaths) );

            tcs_hdf_add(aTHX_ loadpaths, val, tcs_is_utf8(aTHX_ self));
        }
        else if(strEQ(keypv, "functions")) {
            tcs_load_function_set(aTHX_ self, val);
        }
        else if(ckWARN(WARN_MISC)) {
            Perl_warner(aTHX_ packWARN(WARN_MISC), "%s: unknown configuration variable '%s'",
                tcs_get_class_name(aTHX_ self), keypv);
            (void)hv_store_ent(hv, key, newSVsv(val), 0U);
        }
    }
}

static void
tcs_configure(pTHX_ SV* const self, HV* const hv, HDF* const hdf, I32 const ax, I32 const items) {
    if(items == 1) {
        SV* const args_ref = ST(0);
        HV* args;
        HE* he;

        SvGETMAGIC(args_ref);

        if(!(SvROK(args_ref) && SvTYPE(SvRV(args_ref)) == SVt_PVHV
                && !SvOBJECT(SvRV(args_ref)) )){
            croak("%s: single parameters to configure must be a HASH ref",
                tcs_get_class_name(aTHX_ self));
        }
        args = (HV*)SvRV(args_ref);

        hv_iterinit(args);
        while((he = hv_iternext(args))) {
            tcs_set_config(aTHX_ self, hv, hdf, hv_iterkeysv(he), hv_iterval(args, he));
        }
    }
    else {
        I32 i;

        if( (items % 2) != 0 ){
            croak("%s: odd number of parameters to configure",
                tcs_get_class_name(aTHX_ self));
        }

        for(i = 0; i < items; i += 2){
            tcs_set_config(aTHX_ self, hv, hdf, ST(i), ST(i+1));
        }
    }
}

static PerlIO*
tcs_sv2io(pTHX_ SV* sv, const char* const mode, int const imode, bool* const need_closep) {
    if(isGV(sv) || (SvROK(sv) && (isGV(SvRV(sv)) || SvTYPE(SvRV(sv)) == SVt_PVIO))){
        return IoIFP(sv_2io(sv));
    }
    else {
        PerlIO* const fp = PerlIO_openn(aTHX_
            NULL, mode, -1, imode, 0, NULL, 1, &sv);
        if(!fp){
            croak("Cannot open %"SVf": %"SVf, sv, get_sv("!", GV_ADD));
        }
        *need_closep = TRUE;
        return fp;
    }
}

void
tcs_register_funcs(pTHX_ CSPARSE* const cs, HV* const funcs) {

    /* functions registered by users */
    if(funcs) {
        dMY_CXT;
        char* key;
        I32 keylen;
        SV* val;

        SAVEVPTR(MY_CXT.functions);
        MY_CXT.functions = funcs;

        hv_iterinit(funcs);
        while((val = hv_iternextsv(funcs, &key, &keylen))) {
            AV* pair;
            if(!(SvROK(val) && SvTYPE(SvRV(val)) == SVt_PVAV)){
                croak("Function entry for %s() is broken", key);
            }
            pair = (AV*)SvRV(val);

            CHECK_ERR( cs_register_function(cs, key,
                SvIVx(*av_fetch(pair, 1, TRUE)), tcs_function_wrapper) );
        }
    }

    /* functions from cgi_register_strfuncs() */
    CHECK_ERR( cgi_register_strfuncs(cs) );
}

void*
tcs_get_struct_ptr(pTHX_ SV* const arg, const char* const klass,
        const char* const func_fq_name, const char* var_name) {
    if(SvROK(arg) && sv_derived_from(arg, klass) && SvIOK(SvRV(arg))){
        return INT2PTR(void*, SvIVX(SvRV(arg)));
    }

    croak("%s: %s is not of type %s", func_fq_name, var_name, klass);
    return NULL; /* NOT REACHED */
}

#define register_function(self, name, cb, nargs) tcs_register_function(aTHX_ self, name, cb, nargs)

#line 560 "xs/ClearSilver.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 704 "xs/ClearSilver.c"
#ifdef USE_ITHREADS
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Text__ClearSilver_CLONE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver_CLONE)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 578 "xs/ClearSilver.xs"
{
    MY_CXT_CLONE;
    MY_CXT.sort_cmp_cb = NULL;
    MY_CXT.functions   = NULL;
    MY_CXT.input_layer = NULL;
    MY_CXT.file_cache  = newHV();
    PERL_UNUSED_VAR(items);
}
#line 725 "xs/ClearSilver.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Text__ClearSilver_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "klass, ...");
    {
	SV*	klass = ST(0)
;
#line 592 "xs/ClearSilver.xs"
{
    HDF* hdf;
    SV* self;
    HV* hv;
    if(SvROK(klass)){
        croak("Cannot %s->new as an instance method", "Text::ClearSilver");
    }
    hv    = newHV();
    self  = sv_2mortal( newRV_noinc((SV*)hv) );
    ST(0) = sv_bless(self, gv_stashsv(klass, GV_ADD));

    CHECK_ERR( hdf_init(&hdf) );
    sv_setref_pv(*hv_fetchs(hv, "dataset", TRUE), C_HDF, hdf);

    /* ax+1 && items-1 for shift @_ */
    tcs_configure(aTHX_ self, hv, hdf, ax + 1, items - 1);
    XSRETURN(1);
}
#line 760 "xs/ClearSilver.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver_register_function); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver_register_function)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "self, name, func, n_args= -1");
    {
	SV*	self = ST(0)
;
	SV*	name = ST(1)
;
	SV*	func = ST(2)
;
	int	n_args;

	if (items < 4)
	    n_args = -1;
	else {
	    n_args = (int)SvIV(ST(3))
;
	}

	register_function(self, name, func, n_args);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Text__ClearSilver_dataset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver_dataset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV*	self = ST(0)
;
#line 618 "xs/ClearSilver.xs"
{
    ST(0) = *hv_fetchs(tcs_deref_hv(aTHX_ self), "dataset", TRUE);
    XSRETURN(1);
}
#line 808 "xs/ClearSilver.c"
    }
    XSRETURN(1);
}

#define DEFAULT_OUT ((SV*)PL_defoutgv)

XS_EUPXS(XS_Text__ClearSilver_process); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver_process)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "self, src, vars, dest= DEFAULT_OUT, ...");
    {
	SV*	self = ST(0)
;
	SV*	src = ST(1)
;
	SV*	vars = ST(2)
;
	SV* volatile	dest;

	if (items < 4)
	    dest = DEFAULT_OUT;
	else {
	    dest = ST(3)
;
	}
#line 629 "xs/ClearSilver.xs"
{
    dMY_CXT;
    dXCPT;
    CSPARSE*  cs         = NULL;
    HDF*     hdf         = NULL;
    bool need_ifp_close  = FALSE;
    bool need_ofp_close  = FALSE;
    PerlIO* volatile ifp = NULL;
    PerlIO* volatile ofp = NULL;
    bool save_utf8;
    const char* save_input_layer;

    if(!( SvROK(self) && SvOBJECT(SvRV(self)) )){
        croak("Cannot %s->process as a class method", "Text::ClearSilver");
    }

    SvGETMAGIC(src);
    SvGETMAGIC(dest);

    save_utf8   = MY_CXT.utf8;
    MY_CXT.utf8 = FALSE;

    save_input_layer   = MY_CXT.input_layer;
    MY_CXT.input_layer = NULL;

    XCPT_TRY_START {
        HV* const hv = tcs_deref_hv(aTHX_ self);
        const char* input_layer;
        SV** svp;

        CHECK_ERR( hdf_init(&hdf) );

        CHECK_ERR( hdf_copy(hdf, "", (HDF*)tcs_get_struct_ptr(aTHX_
            *hv_fetchs(hv, "dataset", TRUE), C_HDF, "Text::ClearSilver::process", "dataset")) );

        if(!(SvROK(dest) && SvTYPE(SvRV(dest)) <= SVt_PVMG)) { /* not a scalar ref */
            ofp = tcs_sv2io(aTHX_ dest, "w", O_WRONLY|O_CREAT|O_TRUNC, &need_ofp_close);
        }

        MY_CXT.utf8 = tcs_is_utf8(aTHX_ self);

        svp = NULL;
        if(items > 4){
            HV* const local_hv = newHV();
            sv_2mortal((SV*)local_hv);
            tcs_configure(aTHX_ self, local_hv, hdf, ax + 4, items - 4);

            svp = hv_fetchs(local_hv, "utf8", FALSE);
            if(svp) {
                MY_CXT.utf8 = sv_true(*svp);
            }

            svp = hv_fetchs(local_hv, "input_layer", FALSE);
        }
        if(!svp){
            svp = hv_fetchs(hv, "input_layer", FALSE);
        }

        if(svp) {
            input_layer = SvPV_nolen_const(*svp);
        }
        else if(MY_CXT.utf8) {
            input_layer = ":utf8";
        }
        else {
            input_layer = NULL;
        }

        tcs_hdf_add(aTHX_ hdf, vars, MY_CXT.utf8);

        CHECK_ERR( cs_init(&cs, hdf) );

        svp = hv_fetchs(hv, "functions", FALSE);
        tcs_register_funcs(aTHX_ cs, svp ? tcs_deref_hv(aTHX_ *svp) : NULL);

        cs_register_fileload(cs, cs, tcs_fileload);

        MY_CXT.input_layer = input_layer;

        /* parse CS template */
        if(SvROK(src)){
            if(SvTYPE(SvRV(src)) > SVt_PVMG){
                croak("Source must be a scalar reference or a filename, not %"SVf, src);
            }
            CHECK_ERR( tcs_parse_sv(aTHX_ cs, SvRV(src)) );
        }
        else {
            CHECK_ERR( cs_parse_file(cs, SvPV_nolen_const(src)) );
        }

        /* render */
        if(ofp) {
            if(MY_CXT.utf8 && !PerlIO_isutf8(ofp)) {
                PerlIO_binmode(aTHX_ ofp, '>', O_TEXT, ":utf8");
            }
            CHECK_ERR( cs_render(cs, ofp, tcs_output_to_io) );
        }
        else {
            sv_setpvs(SvRV(dest), "");
            if(MY_CXT.utf8) {
                SvUTF8_on(SvRV(dest));
            }
            CHECK_ERR( cs_render(cs, SvRV(dest), tcs_output_to_sv) );
        }
    }
    XCPT_TRY_END

    MY_CXT.utf8        = save_utf8;
    MY_CXT.input_layer = save_input_layer;

    if(need_ifp_close) PerlIO_close(ifp);
    if(need_ofp_close) PerlIO_close(ofp);

    cs_destroy(&cs);
    hdf_destroy(&hdf);

    XCPT_CATCH {
        XCPT_RETHROW;
    }
}
#line 957 "xs/ClearSilver.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Text__ClearSilver_clear_cache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver_clear_cache)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
#line 754 "xs/ClearSilver.xs"
{
    dMY_CXT;
    if(MY_CXT.file_cache){
        ST(0) = sv_2mortal(newRV_noinc((SV*)MY_CXT.file_cache));
        MY_CXT.file_cache = newHV();
    }
    else {
        ST(0) = &PL_sv_undef;
    }
    XSRETURN(1);
}
#line 982 "xs/ClearSilver.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Text__ClearSilver); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Text__ClearSilver)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

#if XSubPPtmpAAAA
        newXS_deffile("Text::ClearSilver::CLONE", XS_Text__ClearSilver_CLONE);
#endif
        newXS_deffile("Text::ClearSilver::new", XS_Text__ClearSilver_new);
        newXS_deffile("Text::ClearSilver::register_function", XS_Text__ClearSilver_register_function);
        newXS_deffile("Text::ClearSilver::dataset", XS_Text__ClearSilver_dataset);
        newXS_deffile("Text::ClearSilver::process", XS_Text__ClearSilver_process);
        newXS_deffile("Text::ClearSilver::clear_cache", XS_Text__ClearSilver_clear_cache);

    /* Initialisation Section */

#line 555 "xs/ClearSilver.xs"
{
    XS(boot_Text__ClearSilver__HDF);
    XS(boot_Text__ClearSilver__CS);
    MY_CXT_INIT;
    MY_CXT.sort_cmp_cb = NULL;
    MY_CXT.functions   = NULL;
    MY_CXT.input_layer = NULL;
    MY_CXT.file_cache  = newHV();

    PUSHMARK(SP);
    boot_Text__ClearSilver__HDF(aTHX_ cv);
    SPAGAIN;

    PUSHMARK(SP);
    boot_Text__ClearSilver__CS(aTHX_ cv);
    SPAGAIN;
}

#if XSubPPtmpAAAA
#endif
#line 1047 "xs/ClearSilver.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

