/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of HDF.xs. Do not edit this file, edit HDF.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "xs/HDF.xs"
/*
    Text-ClearSilver-HDF.xs - Represents the HDF* class

    Copyright(c) 2010 Craftworks. All rights reserved.

    See lib/Text/ClearSilver.pm for details.
*/

#define NEED_pv_pretty
#define NEED_pv_escape
#define NEED_my_snprintf
#include "Text-ClearSilver.h"


static int
tcs_cmp(const void* const in_a, const void* const in_b) {
    dTHX;
    dSP;
    SV* const sort_cmp_cb = tcs_get_my_cxtp(aTHX)->sort_cmp_cb;
    SV* a;
    SV* b;
    int ret;

    assert(sort_cmp_cb);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);

    /* convert to a type Perl can access */
    a = sv_newmortal();
    sv_setref_pv(a, C_HDF, *((HDF**)in_a));

    b = sv_newmortal();
    sv_setref_pv(b, C_HDF, *((HDF**)in_b));

    EXTEND(SP, 2);
    PUSHs(a);
    PUSHs(b);

    PUTBACK;

    call_sv(sort_cmp_cb, G_SCALAR);

    SPAGAIN;
    ret = POPi;
    PUTBACK;

    FREETMPS;
    LEAVE;

    return ret;
}

static void
tcs_croak_with_pv(pTHX_ const char* const name, const char* const pv, STRLEN const pvlen) {
    croak("The %s (%s) is not utf8-flagged nor utf8-encoded", name,
        pv_pretty(sv_newmortal(), pv, pvlen, 128, NULL, NULL, PERL_PV_PRETTY_DUMP));
}

static void
tcs_hdf_walk(pTHX_ HDF* const hdf, SV* const key, SV* const sv, HV* const seen, bool const utf8) {
    SvGETMAGIC(sv);
    if(SvROK(sv)){
        SV** seen_key;
        SV* const rv = SvRV(sv);

        if(SvOBJECT(rv)){
            /* What we should do? */
            goto set_sv;
        }

        seen_key = hv_fetch(seen, (const char*)rv, sizeof(rv), FALSE);
        if(seen_key){
            hdf_set_symlink(hdf, SvPV_nolen_const(key), SvPV_nolen_const(*seen_key));
            return;
        }

        (void)hv_store(seen, (const char*)rv, sizeof(rv), newSVsv(key), 0U);

        if(SvTYPE(rv) == SVt_PVAV || SvTYPE(rv) == SVt_PVHV) {
            STRLEN pos = SvCUR(key);

            if(pos != 0){ /* append '.' if key is not empty */
                sv_catpvs(key, ".");
                pos++;
            }

            if(SvTYPE(rv) == SVt_PVAV){
                AV* const av  = (AV*)rv;
                I32 const len = av_len(av) + 1;
                I32 i;
                for(i = 0; i < len; i++){
                    SV** const svp = av_fetch(av, i, FALSE);
                    if(svp){
                        sv_catpvf(key, "%d", (int)i);
                        tcs_hdf_walk(aTHX_ hdf, key, *svp, seen, utf8);
                        SvCUR_set(key, pos); /* reset key */
                        *SvEND(key) = '\0';
                    }
                }
            }
            else { /* SVt_PVHV */
                HV* const hv = (HV*)rv;
                char* keypv;
                I32   keylen;
                SV*   valsv;

                hv_iterinit(hv);
                while((valsv = hv_iternextsv(hv, &keypv, &keylen))){
                    sv_catpvn(key, keypv, keylen);
                    tcs_hdf_walk(aTHX_ hdf, key, valsv, seen, utf8);
                    SvCUR_set(key, pos);
                    *SvEND(key) = '\0';
                }
            }

            /* chop the last '.' */
            if(pos != 0 && SvPVX(key)[pos-1] == '.'){
                SvCUR_set(key, pos - 1);
                *SvEND(key) = '\0';
            }

            return;
        }

        /* fall through */
    }

    set_sv:
    if(SvOK(sv)) {
        NEOERR* err;
        /* see also Perl_do_printf() in doop.c */
        if( (SvTYPE(sv) & SVf_OK) == SVf_IOK  && PERL_ABS(SvIVX(sv)) <= PERL_LONG_MAX ) {
            err = hdf_set_int_value(hdf, SvPV_nolen_const(key), (long)SvIVX(sv));
        }
        else {
            STRLEN keylen;
            STRLEN vallen;
            const char* const keypv = SvPV_const(key, keylen);
            const char* const valpv = SvPV_const(sv,  vallen);

            if(utf8) {
                if(!( SvUTF8(key) || is_utf8_string((const U8*)keypv, keylen) )) {
                    tcs_croak_with_pv(aTHX_ "key", keypv, keylen);
                }
                if(!( SvUTF8(sv)  || is_utf8_string((const U8*)valpv, vallen) )) {
                    tcs_croak_with_pv(aTHX_ "value", valpv, vallen);
                }
            }

            err = hdf_set_value(hdf, keypv, valpv);
        }

        CHECK_ERR(err);
    }
    /* warn("set %"SVf"=%"SVf"", key, sv); // */
}

void
tcs_hdf_add(pTHX_ HDF* const hdf, SV* const sv, bool const utf8) {
    assert(sv);
    SvGETMAGIC(sv);

    if(SvROK(sv)){
        if(SvOBJECT(SvRV(sv)) && SvIOK(SvRV(sv)) && sv_derived_from(sv, C_HDF)) {
            CHECK_ERR( hdf_copy(hdf, "" /* root */, INT2PTR(HDF*, SvIVX(SvRV(sv)) )) );
        }
        else {
            SV* const key  = newSV(80);
            HV* const seen = newHV();
            sv_2mortal((SV*)seen);
            sv_2mortal(key);
            sv_setpvs(key, "");

            tcs_hdf_walk(aTHX_ hdf, key, sv, seen, utf8);
        }
    }
    else if(SvOK(sv)){
        CHECK_ERR( hdf_read_string(hdf, SvPV_nolen_const(sv)) );
    }
}

HDF*
tcs_new_hdf(pTHX_ SV* const sv) {
    HDF* hdf;

    CHECK_ERR( hdf_init(&hdf) );

    if(sv){
        tcs_hdf_add(aTHX_ hdf, sv, FALSE);
    }

    return hdf;
}

/*
    NOTE: Methods which seem to return NEOERR* throw errors when they fail,
          otherwise return undef.
 */

#line 213 "xs/HDF.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 357 "xs/HDF.c"

XS_EUPXS(XS_Text__ClearSilver__HDF_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "klass, arg= NULL");
    {
	SV*	klass = ST(0)
;
	SV*	arg;

	if (items < 2)
	    arg = NULL;
	else {
	    arg = ST(1)
;
	}
#line 210 "xs/HDF.xs"
{
    SV* self;
    if(SvROK(klass)){
        croak("%s->new must be called as a class method", C_CS);
    }

    self = sv_newmortal();
    sv_setref_pv(self, SvPV_nolen_const(klass), tcs_new_hdf(aTHX_ arg));
    ST(0) = self;
    XSRETURN(1);
}
#line 388 "xs/HDF.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdf");
    {
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::DESTROY", "hdf")
;

	hdf_DESTROY(hdf);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Text__ClearSilver__HDF_set_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_set_value)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hdf, key, value");
    {
	NEOERR *	RETVAL;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::set_value", "hdf")
;
	const char*	key = (const char *)SvPV_nolen(ST(1))
;
	const char*	value = (const char *)SvPV_nolen(ST(2))
;

	RETVAL = hdf_set_value(hdf, key, value);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    CHECK_ERR(RETVAL);
    sv_setiv(RETVALSV, TRUE);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_get_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_get_value)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "hdf, key, default_value= NULL");
    {
	const char *	RETVAL;
	dXSTARG;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::get_value", "hdf")
;
	const char*	key = (const char *)SvPV_nolen(ST(1))
;
	const char*	default_value;

	if (items < 3)
	    default_value = NULL;
	else {
	    default_value = (const char *)SvPV_nolen(ST(2))
;
	}

	RETVAL = hdf_get_value(hdf, key, default_value);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_copy)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dest, name, src");
    {
	NEOERR *	RETVAL;
	Text__ClearSilver__HDF    dest = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::copy", "dest")
;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;
	Text__ClearSilver__HDF    src = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(2), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::copy", "src")
;

	RETVAL = hdf_copy(dest, name, src);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    CHECK_ERR(RETVAL);
    sv_setiv(RETVALSV, TRUE);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_read_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_read_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdf, filename");
    {
	NEOERR *	RETVAL;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::read_file", "hdf")
;
	const char*	filename = (const char *)SvPV_nolen(ST(1))
;

	RETVAL = hdf_read_file(hdf, filename);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    CHECK_ERR(RETVAL);
    sv_setiv(RETVALSV, TRUE);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_read_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_read_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdf, str");
    {
	NEOERR *	RETVAL;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::read_string", "hdf")
;
	const char*	str = (const char *)SvPV_nolen(ST(1))
;

	RETVAL = hdf_read_string(hdf, str);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    CHECK_ERR(RETVAL);
    sv_setiv(RETVALSV, TRUE);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define HDF_DUMP_TYPE_DOTTED  0
#define HDF_DUMP_TYPE_COMPACT 1
#define HDF_DUMP_TYPE_PRETTY  2

XS_EUPXS(XS_Text__ClearSilver__HDF_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_dump)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "hdf, dump_type= HDF_DUMP_TYPE_PRETTY");
    {
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::dump", "hdf")
;
	int	dump_type;

	if (items < 2)
	    dump_type = HDF_DUMP_TYPE_PRETTY;
	else {
	    dump_type = (int)SvIV(ST(1))
;
	}
#line 247 "xs/HDF.xs"
{
    dXSTARG;
    STRING str;

    string_init(&str);
    hdf_dump_str(hdf, "", dump_type, &str);
    sv_setpvn(TARG, str.buf, str.len);
    string_clear(&str);

    ST(0) = TARG;
    XSRETURN(1);
}
#line 588 "xs/HDF.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_write_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_write_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdf, dest");
    {
	NEOERR *	RETVAL;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::write_file", "hdf")
;
	SV*	dest = ST(1)
;
#line 263 "xs/HDF.xs"
{
    bool ok;
    STRING str;
    PerlIO* const ofp = PerlIO_openn(aTHX_
        NULL, "w", -1, O_WRONLY | O_CREAT, 0, NULL, 1, &dest);

    string_init(&str);
    RETVAL = hdf_dump_str(hdf, "", HDF_DUMP_TYPE_PRETTY, &str);

    ok = ( PerlIO_write(ofp, str.buf, str.len) == str.len );

    string_clear(&str);
    if(PerlIO_close(ofp) == -1){
        ok = FALSE;
    }

    if(!ok){
        croak("Cannot finish hdf_write_file: %"SVf, get_sv("!", GV_ADD));
    }
}
#line 628 "xs/HDF.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_get_obj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_get_obj)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdf, name");
    {
	Text__ClearSilver__HDF	RETVAL;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::get_obj", "hdf")
;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;

	RETVAL = hdf_get_obj(hdf, name);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Text::ClearSilver::HDF", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_get_child); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_get_child)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdf, name");
    {
	Text__ClearSilver__HDF	RETVAL;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::get_child", "hdf")
;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;

	RETVAL = hdf_get_child(hdf, name);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Text::ClearSilver::HDF", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_obj_child); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_obj_child)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdf");
    {
	Text__ClearSilver__HDF	RETVAL;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::obj_child", "hdf")
;

	RETVAL = hdf_obj_child(hdf);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Text::ClearSilver::HDF", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_obj_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_obj_value)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdf");
    {
	const char *	RETVAL;
	dXSTARG;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::obj_value", "hdf")
;

	RETVAL = hdf_obj_value(hdf);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_obj_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_obj_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	const char *	RETVAL;
	dXSTARG;
	Text__ClearSilver__HDF    self = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::obj_name", "self")
;

	RETVAL = hdf_obj_name(self);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_obj_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_obj_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdf");
    {
	Text__ClearSilver__HDF	RETVAL;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::obj_next", "hdf")
;

	RETVAL = hdf_obj_next(hdf);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Text::ClearSilver::HDF", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_sort_obj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_sort_obj)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdf, cb");
    {
	NEOERR *	RETVAL;
	Text__ClearSilver__HDF    hdf = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::sort_obj", "hdf")
;
	SV*	cb = ST(1)
;
#line 305 "xs/HDF.xs"
{
    my_cxt_t* const cxt = tcs_get_my_cxtp(aTHX);
    SAVEVPTR(cxt->sort_cmp_cb);
    cxt->sort_cmp_cb = cb;
    RETVAL = hdf_sort_obj(hdf, tcs_cmp);
}
#line 794 "xs/HDF.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    CHECK_ERR(RETVAL);
    sv_setiv(RETVALSV, TRUE);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_set_symlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_set_symlink)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, src, dest");
    {
	NEOERR *	RETVAL;
	Text__ClearSilver__HDF    self = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::set_symlink", "self")
;
	const char*	src = (const char *)SvPV_nolen(ST(1))
;
	const char*	dest = (const char *)SvPV_nolen(ST(2))
;

	RETVAL = hdf_set_symlink(self, src, dest);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    CHECK_ERR(RETVAL);
    sv_setiv(RETVALSV, TRUE);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__ClearSilver__HDF_remove_tree); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__ClearSilver__HDF_remove_tree)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, name");
    {
	NEOERR *	RETVAL;
	Text__ClearSilver__HDF    self = (Text__ClearSilver__HDF)tcs_get_struct_ptr(aTHX_ ST(0), "Text::ClearSilver::HDF",
            "Text::ClearSilver::HDF::remove_tree", "self")
;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;

	RETVAL = hdf_remove_tree(self, name);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    CHECK_ERR(RETVAL);
    sv_setiv(RETVALSV, TRUE);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Text__ClearSilver__HDF); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Text__ClearSilver__HDF)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Text::ClearSilver::HDF::new", XS_Text__ClearSilver__HDF_new);
        newXS_deffile("Text::ClearSilver::HDF::DESTROY", XS_Text__ClearSilver__HDF_DESTROY);
        newXS_deffile("Text::ClearSilver::HDF::set_value", XS_Text__ClearSilver__HDF_set_value);
        newXS_deffile("Text::ClearSilver::HDF::get_value", XS_Text__ClearSilver__HDF_get_value);
        newXS_deffile("Text::ClearSilver::HDF::copy", XS_Text__ClearSilver__HDF_copy);
        newXS_deffile("Text::ClearSilver::HDF::read_file", XS_Text__ClearSilver__HDF_read_file);
        newXS_deffile("Text::ClearSilver::HDF::read_string", XS_Text__ClearSilver__HDF_read_string);
        newXS_deffile("Text::ClearSilver::HDF::dump", XS_Text__ClearSilver__HDF_dump);
        newXS_deffile("Text::ClearSilver::HDF::write_file", XS_Text__ClearSilver__HDF_write_file);
        newXS_deffile("Text::ClearSilver::HDF::get_obj", XS_Text__ClearSilver__HDF_get_obj);
        newXS_deffile("Text::ClearSilver::HDF::get_child", XS_Text__ClearSilver__HDF_get_child);
        newXS_deffile("Text::ClearSilver::HDF::obj_child", XS_Text__ClearSilver__HDF_obj_child);
        newXS_deffile("Text::ClearSilver::HDF::obj_value", XS_Text__ClearSilver__HDF_obj_value);
        newXS_deffile("Text::ClearSilver::HDF::obj_name", XS_Text__ClearSilver__HDF_obj_name);
        newXS_deffile("Text::ClearSilver::HDF::obj_next", XS_Text__ClearSilver__HDF_obj_next);
        newXS_deffile("Text::ClearSilver::HDF::sort_obj", XS_Text__ClearSilver__HDF_sort_obj);
        newXS_deffile("Text::ClearSilver::HDF::set_symlink", XS_Text__ClearSilver__HDF_set_symlink);
        newXS_deffile("Text::ClearSilver::HDF::remove_tree", XS_Text__ClearSilver__HDF_remove_tree);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

